import gulp from 'gulp';
import browser from 'browser-sync';
import webpack from 'webpack';

import webpackDevMiddleware from 'webpack-dev-middleware';

import webpackHotMiddleware from 'webpack-hot-middleware';

import { config } from './webpack';

import conf from './conf';

import { serveContent } from './serve-content';

// import { serveHTML } from './serve-html';

// import { servePHP } from './serve-php';

// import { serveImages } from './serve-images';

// import { serveOur, serveRoot } from './serve-source';

import { serveCoreCSS } from './serve-css--core';

import { serveMainCSS } from './serve-css--main';

const bs = browser.create();

const bundler = webpack(config);

// import modRewrite from 'connect-modrewrite';

export function server () {
    bs.init({
        logPrefix: conf.name,
        proxy: conf.proxy,
        // httpModule: 'http2',
        https: {
            key: conf.certs.key,
            cert: conf.certs.cert
        },
        files: [
            `wp-content/themes/${conf.name}/**/*.php`,
            `wp-content/themes/${conf.name}/css/main.min.css`
        ],
        open: false,
        port: 2000,
        ui: false,
        middleware: [
            webpackDevMiddleware(bundler, { /* options */ }),
            webpackHotMiddleware(bundler)
            // modRewrite([
            //   '^[^\\.]*$ /index.html [L]',
            //   // '^/wp-json/our-wp-api/v1/(.*)$ https://town.biuro.lt/wp-json/our-wp-api/v1/$1 [P]',
            //   // '^http://town.loc.al/wp-content/uploads/2018/03/(.*)$ https://town.biuro.lt/wp-content/uploads/2018/03/$1 [P]',
            // ]),
        ]
    });

    gulp.watch('wp-content/content/**/*.*').on('change', () => {
        serveContent();
        bs.reload();
    });

    gulp.watch([`wp-content/themes/${conf.name}/css/**/*.css`, `!wp-content/themes/${conf.name}/css/**/*.min.css`], gulp.parallel(serveCoreCSS, serveMainCSS));

    gulp.watch(`wp-content/themes/${conf.name}/css/core.min.css`).on('change', () => bs.reload());

    // gulp.watch(`wp-content/themes/${conf.name}/js/*.js`).on('change', () => bs.reload());
}
